<?php
	/**
	 * -----------------------------------------
	 * @author Nico Schubert / www.php-space.info
	 * @copyright Das Script kann unter Verwendung des Copyright uneingeschrnkt genutzt / verndert werden. Das Copyright muss im Code sowie in der Ausgabe erhalten bleiben.
	 * @version Simple PHP Forum 1.03 - 21.08.2011
	 * @abstract Das Script luft erst ab der Php Version 5.0 oder hher. Wenn Sie Probleme mit den Einrichten haben, so schauen Sie bitte in die Anleitung -> Installationsanleitung_1.01.pdf
	 * -----------------------------------------
	*/
class DBI {
	public $DBD;
	public $CONN;
	public $CONFIG;

	public $DBTYPE;

	public $prepare = "";
	public $row     = array();


	function error($str)
	{
		echo "$str<BR>\n";
		exit;

	} // End Error

	function DBI($datenbank_host, $datenbank_name,$datenbank_user, $datenbank_password, $cachedir)
	{
		$this->dbsocket = '3306';
		$this->dbhost 	= $datenbank_host;
		$this->dbname 	= $datenbank_name;
		$this->dbuser 	= $datenbank_user;
		$this->dbpwd  	= $datenbank_password;
		$this->cachedir = $cachedir;
		$this->DBTYPE  	= 'mysql';
		$DBDClass = 'DBD_'.$this->DBTYPE;
		$this->DBD = new $DBDClass($this);
	}

	function connect()
	{
		if( $this->DBTYPE == 'mysql' )
		{
			$this->CONN = $this->DBD->connect(
				$this->dbname,
				( ( strlen( $this->dbsocket ) ) ? ":". $this->dbsocket : $this->dbhost.":".$this->dbport ),
				$this->dbuser,
				$this->dbpwd
			);
		}
		else {
			$this->CONN = $this->DBD->connect(
				$this->dbname,
				$this->dbhost,
				$this->dbuser,
				$this->dbpwd,
				$this->dbport,
				( strlen( $this->dbsocket ) ? $this->dbsocket : false )
			);
		}

		return true;

	} // End Connect

	function disconnect()
	{
		if($this->DBD){
			$this->DBD->disconnect();
		}
	} // End Disconnect

	function prepare($query,$cache = 0)
	{
		$sth = $this->DBD->prepare($query, $cache);
		return($sth);

	} // End Prepare

}	// End Class

class DBD_mysql {

	public $CONFIG;
	public $DBI;
	public $dbh;

	function DBD_mysql($pConfig = false)
	{
		if ($pConfig !== false) {
			$this->CONFIG = $pConfig;
		}
	}

	function error($str)
	{

		echo ($str);

	} // End Error

	function connect($dbname, $dbhost = '', $dbuser = '', $dbpwd = ''){

		$conn = @mysql_connect($dbhost, $dbuser, $dbpwd);
		if(!$conn) {
			$this->error("DBD::mysql Error: Could not connect to the database.");
			return;
		}

		if(!mysql_select_db($dbname)) {
			$this->error("DBD::mysql Error: Could not select the database.");
			return;
		}

		$this->dbh = $conn;

		return($this);

	} // End Connect

	function disconnect( )
	{
		if($this->dbh){
			mysql_close($this->dbh);
		}
		unset( $this->dbh );

		return(1);

	} // End Disconnect

	function prepare($query, $cache = 0)
	{
		$sth = new STH_mysql;
		$sth->DBH($this);
		$sth->prepare($query, $cache, $this->CONFIG->cachedir);
		return($sth);

	} // End Prepare

} // End DBD Class

class STH_mysql {

	public $query;
	public $DBH;
	public $dbh;
	public $result;
	public $cache;

	function error($str)
	{
		echo "$str<BR>\n";
		exit;

	} // End Error

	function DBH(&$dbh)
	{
		$this->DBH = &$dbh;
		$this->dbh = &$dbh->dbh;
		return( $dbh );
	}

	function prepare($query, $cache, $cachedir)
	{
		if ($cache && preg_match("!SELECT!", trim($query))) {
			$this->cache['sth'] = new CACHE($cache);
			$this->cache['file'] = $cachedir.md5($query);
			if( isset($_GET['dbdebug']) ) echo "<p>Prepare $query (".md5($query).")";
		}
		$this->query = $query;
		return($query);
	}

	function execute()
	{
		if(is_array($this->cache)){

			$this->cache['data']['row']['array'] = array();
			$this->cache['data']['row']['hash'] = array();
			$this->cache['data']['row']['hashref'] = array();

			if( isset($_GET['dbdebug']) ) echo "<p>READ CACHE: ".substr( $this->query, 0, 30 )."... ";

			if($this->cache['sth']->read_cache_file($this->cache['file'], $this->cache['data'])){
				$this->cache['data'] = unserialize(base64_decode($this->cache['data']));
				$this->result = $this->cache['data']['result'];
			}
			if( !$this->result ) {
				$this->cache['init'] = true;
				if(!$this->dbh){
					$this->DBH->connect(
						$this->DBH->CONFIG->dbname,
						( ( strlen( $this->DBH->CONFIG->dbsocket ) ) ? $this->DBH->CONFIG->dbhost: $this->DBH->CONFIG->dbhost.":".$this->DBH->CONFIG->dbport ),
						$this->DBH->CONFIG->dbuser,
						$this->DBH->CONFIG->dbpwd
					);
				}
				$this->result = @mysql_query($this->query, $this->dbh);

				$this->cache['data']['result'] = ( $this->result ) ? 1 : 0;
			}
		}
		else{
			if(!$this->dbh){
				$this->DBH->connect(
					$this->DBH->CONFIG->dbname,
					( ( strlen( $this->DBH->CONFIG->dbsocket ) ) ? $this->DBH->CONFIG->dbhost : $this->DBH->CONFIG->dbhost.":".$this->DBH->CONFIG->dbport ),
					$this->DBH->CONFIG->dbuser,
					$this->DBH->CONFIG->dbpwd
				);
			}
			$this->result = @mysql_query($this->query, $this->dbh);

		}

		if(!$this->result)
		{
			return(0);
		}

		return(1);

	} // End Execute

	function insert_id()
	{
		return(mysql_insert_id($this->dbh));

	} // End Insert_ID

	function finish()
	{
		if(!$this->result){ return; }

		if(!is_array($this->cache) || isset($this->cache['init'])){

			@mysql_free_result($this->result);

			if(isset($this->cache['init'] ) ){

				if( isset($_GET['dbdebug']) ) echo "<p>WRITE CACHE: ".substr( $this->query, 0, 30 )."... ";
				$this->cache['sth']->write_cache_file($this->cache['file'], $xxx = base64_encode(serialize($this->cache['data'])));
				//$this->cache['sth']->$xyFoo;

			}
		}
		unset( $this->result );

		return(1);

	} // End Finish

	function fields()
	{
		$fields = 0;
		if(!is_array($this->cache) || isset($this->cache['init'])){
			$fields = @mysql_num_fields($this->result);
			if(isset($this->cache['init'])){
				$this->cache['data']['fields'] = $fields;
			}
		}
		elseif(isset($this->cache['data']['fields'])){
			$fields = $this->cache['data']['fields'];
		}

		return $fields;

	} // End Rows

	function rows()
	{
		$rows = 0;
		if(!is_array($this->cache) || isset($this->cache['init'])){
			$rows = @mysql_num_rows($this->result);
			if(isset($this->cache['init'])){
				$this->cache['data']['rows'] = $rows;
			}
		}
		elseif(isset($this->cache['data']['rows'])){
			$rows = $this->cache['data']['rows'];
		}
		return $rows;

	} // End Rows

	function affected()
	{
		$rows = 0;
		if(!is_array($this->cache) || isset($this->cache['init'])){
			$rows = @mysql_affected_rows($this->dbh);
			if(isset($this->cache['init'])){
				$this->cache['data']['affected'] = $rows;
			}
		}
		elseif(isset($this->cache['data']['affected'])){
			$rows = $this->cache['data']['affected'];
		}
		return $rows;

	} // End Rows

	function fetchrow_array()
	{
		if(!$this->result){
			//echo "STH Error: Calling fetchrow on null result.<br>\n";
			return;
		}
		$row = false;
		if(!is_array($this->cache) || isset($this->cache['init'])){
			$row = mysql_fetch_array($this->result);
			if(isset($this->cache['init'])){
				$this->cache['data']['row']['array'][] = $row;
			}
		}
		elseif(isset($this->cache['data']['row']['array'])){
			$row = array_shift($this->cache['data']['row']['array']);
		}
		return($row);

	} // End Fetchrow_array

	function fetchrow_hash()
	{
		if(!$this->result){
			//echo "STH Error: Calling fetchrow on null result.<br>\n";
			return;
		}
		$row = false;
		if(!is_array($this->cache) || isset($this->cache['init'])){
			$row = mysql_fetch_assoc($this->result);
			if(isset($this->cache['init'])){
				$this->cache['data']['row']['hash'][] = $row;
			}
		}
		elseif(isset($this->cache['data']['row']['hash'])){
			$row = array_shift($this->cache['data']['row']['hash']);
		}
		return($row);

	} // End Fetchrow_hash

	function fetchrow_hashref()
	{
		if(!$this->result){
			//echo "STH Error: Calling fetchrow on null result.<br>\n";
			return;
		}
		$row = false;
		if(!is_array($this->cache) || isset($this->cache['init'])){
			$row = mysql_fetch_object($this->result);
			if(isset($this->cache['init'])){
				$this->cache['data']['row']['hashref'][] = $row;
			}
		}
		elseif(isset($this->cache['data']['row']['hashref'])){
			$row = array_shift($this->cache['data']['row']['hashref']);
		}
		return($row);

	} // End Fetchrow_hashref

	function fetchrow_field()
	{
		if(!$this->result){
			//echo "STH Error: Calling fetchrow on null result.<br>\n";
			return;
		}
		$row = false;
		if(!is_array($this->cache) || isset($this->cache['init'])){
			$row = mysql_fetch_field($this->result);
			if(isset($this->cache['init'])){
				$this->cache['data']['row']['field'][] = $row;
			}
		}
		elseif(isset($this->cache['data']['row']['field'])){
			$row = array_shift($this->cache['data']['row']['field']);
		}
		return($row);

	} // End Fetchrow_field

} // End Class STH

class DBD_mysqli {

	public $CONFIG;
	public $DBI;
	public $dbh;

	function DBD_mysqli($pConfig = false)
	{
		if ($pConfig !== false) {
			$this->CONFIG = $pConfig;
		}
	}

	function error($str)
	{

		echo ($str);

	} // End Error

	function connect($dbname, $dbhost = '', $dbuser = '', $dbpwd = '', $dbport = 3306, $dbsocket = false ){

		if( $dbsocket === false )
			$conn = mysqli_connect($dbhost, $dbuser, $dbpwd, $dbname, $dbport );
		else
			$conn = mysqli_connect($dbhost, $dbuser, $dbpwd, $dbname, $dbport, $dbsocket );

		if(!$conn) {
			$this->error("DBD::mysql Error: Could not connect to the database.");
			return;
		}

		$this->dbh = $conn;

		return($this);

	} // End Connect

	function disconnect( )
	{
		if($this->dbh){
			mysqli_close($this->dbh);
		}
		unset( $this->dbh );

		return(1);

	} // End Disconnect

	function prepare($query, $cache = 0)
	{
		$sth = new STH_mysqli;
		$sth->DBH($this);
		$sth->prepare($query, $cache);
		return($sth);

	} // End Prepare

} // End DBD Class

class STH_mysqli {

	public $query;
	public $DBH;
	public $dbh;
	public $result;
	public $cache;

	function error($str)
	{
		echo "$str<BR>\n";
		exit;

	} // End Error

	function DBH(&$dbh)
	{
		$this->DBH = &$dbh;
		$this->dbh = &$dbh->dbh;
		return( $dbh );
	}

	function prepare($query, $cache)
	{
		if ($cache && eregi("^SELECT.+", trim($query))) {
			$this->cache['sth'] = new CACHE($cache);
			$this->cache['file'] = "./tmp/".md5($query);
		}
		$this->query = $query;
		return($query);
	}

	function execute()
	{
		if(is_array($this->cache)){

			$this->cache['data']['row']['array'] = array();
			$this->cache['data']['row']['hash'] = array();
			$this->cache['data']['row']['hashref'] = array();

			if($this->cache['sth']->read_cache_file($this->cache['file'], $this->cache['data'])){

				$this->cache['data'] = unserialize(base64_decode($this->cache['data']));
				$this->result = $this->cache['data']['result'];
			}
			if( !$this->result ) {

			$this->cache['init'] = true;
				if(!$this->dbh){
					$this->DBH->connect(
						$this->DBH->CONFIG->dbname,
						$this->DBH->CONFIG->dbhost,
						$this->DBH->CONFIG->dbuser,
						$this->DBH->CONFIG->dbpwd,
						$this->DBH->CONFIG->dbport,
						( strlen( $this->DBH->CONFIG->dbsocket ) ? $this->DBH->CONFIG->dbsocket : false )
					);
				}
				$this->result = @mysqli_query($this->dbh, $this->query);

				$this->cache['data']['result'] = ( $this->result ) ? 1 : 0;
			}
		}
		else{
			if(!$this->dbh){
				$this->DBH->connect(
					$this->DBH->CONFIG->dbname,
					$this->DBH->CONFIG->dbhost,
					$this->DBH->CONFIG->dbuser,
					$this->DBH->CONFIG->dbpwd,
					$this->DBH->CONFIG->dbport,
					( strlen( $this->DBH->CONFIG->dbsocket ) ? $this->DBH->CONFIG->dbsocket : false )
				);
			}
			$this->result = mysqli_query($this->dbh,$this->query);
		}

		if(!$this->result)
		{
			return(0);
		}

		return(1);

	} // End Execute

	function insert_id()
	{
		return(mysqli_insert_id($this->dbh));

	} // End Insert_ID

	function finish()
	{
		if(!$this->result){ return; }

		if(!is_array($this->cache) || isset($this->cache['init'])){

			mysqli_free_result($this->result);

			if(isset($this->cache['init'])){

				$this->cache['sth']->write_cache_file($this->cache['file'], $xxx = base64_encode(serialize($this->cache['data'])));
			}
		}
		unset( $this->result );

		return(1);

	} // End Finish

	function fields()
	{
		$fields = 0;
		if(!is_array($this->cache) || isset($this->cache['init'])){
			$fields = @mysqli_num_fields($this->result);
			if(isset($this->cache['init'])){
				$this->cache['data']['fields'] = $fields;
			}
		}
		elseif(isset($this->cache['data']['fields'])){
			$fields = $this->cache['data']['fields'];
		}

		return $fields;

	} // End Rows

	function rows()
	{
		$rows = 0;
		if(!is_array($this->cache) || isset($this->cache['init'])){
			$rows = mysqli_num_rows($this->result);
			if(isset($this->cache['init'])){
				$this->cache['data']['rows'] = $rows;
			}
		}
		elseif(isset($this->cache['data']['rows'])){
			$rows = $this->cache['data']['rows'];
		}
		return $rows;

	} // End Rows

	function affected()
	{
		$rows = 0;
		if(!is_array($this->cache) || isset($this->cache['init'])){
			$rows = @mysqli_affected_rows($this->dbh);
			if(isset($this->cache['init'])){
				$this->cache['data']['affected'] = $rows;
			}
		}
		elseif(isset($this->cache['data']['affected'])){
			$rows = $this->cache['data']['affected'];
		}
		return $rows;

	} // End Rows

	function fetchrow_array()
	{
		if(!$this->result){
			//echo "STH Error: Calling fetchrow on null result.<br>\n";
			return;
		}
		$row = false;
		if(!is_array($this->cache) || isset($this->cache['init'])){
			$row = mysqli_fetch_array($this->result);
			if(isset($this->cache['init'])){
				$this->cache['data']['row']['array'][] = $row;
			}
		}
		elseif(isset($this->cache['data']['row']['array'])){
			$row = array_shift($this->cache['data']['row']['array']);
		}
		return($row);

	} // End Fetchrow_array

	function fetchrow_hash()
	{
		if(!$this->result){
			//echo "STH Error: Calling fetchrow on null result.<br>\n";
			return;
		}
		$row = false;
		if(!is_array($this->cache) || isset($this->cache['init'])){
			$row = mysqli_fetch_assoc($this->result);
			if(isset($this->cache['init'])){
				$this->cache['data']['row']['hash'][] = $row;
			}
		}
		elseif(isset($this->cache['data']['row']['hash'])){
			$row = array_shift($this->cache['data']['row']['hash']);
		}
		return($row);

	} // End Fetchrow_hash

	function fetchrow_hashref()
	{
		if(!$this->result){
			//echo "STH Error: Calling fetchrow on null result.<br>\n";
			return;
		}
		$row = false;
		if(!is_array($this->cache) || isset($this->cache['init'])){
			$row = mysqli_fetch_object($this->result);
			if(isset($this->cache['init'])){
				$this->cache['data']['row']['hashref'][] = $row;
			}
		}
		elseif(isset($this->cache['data']['row']['hashref'])){
			$row = array_shift($this->cache['data']['row']['hashref']);
		}
		return($row);

	} // End Fetchrow_hashref

	function fetchrow_field()
	{
		if(!$this->result){
			//echo "STH Error: Calling fetchrow on null result.<br>\n";
			return;
		}
		$row = false;
		if(!is_array($this->cache) || isset($this->cache['init'])){
			$row = mysqli_fetch_field($this->result);
			if(isset($this->cache['init'])){
				$this->cache['data']['row']['field'][] = $row;
			}
		}
		elseif(isset($this->cache['data']['row']['field'])){
			$row = array_shift($this->cache['data']['row']['field']);
		}
		return($row);

	} // End Fetchrow_field

} // End Class STH

class CACHE
{

  function CACHE ( $pExpires = 30 ) {

    $this->expires = $pExpires;
  }

  function write_cache_file ( $filename, $data ) {

  	$result = false;

	$fp = @fopen($filename, "w");

  	if ($fp) {
  		if (! @flock($fp, LOCK_EX | LOCK_NB))
  			@fclose($fp);
  	}

  	if ($fp) {
  		@fputs($fp, $data);
  		@fclose($fp);
  		$result = true;
  	}

  	if( $result ) {
  		if( isset($_GET['dbdebug']) ) echo "OK ($filename)";
  	}
  	else {
  		if( isset($_GET['dbdebug']) ) echo "Failed ($filename)";
  	}

  	return $result;
  }

  function read_cache_file ( $filename, &$data ) {

  	$result = false;

  	if ( !$this->expire_cache_file( $filename ) ) {
	  	$fp='';
  		if (@is_readable($filename))
  			$fp = @fopen($filename, "r");

  		if ($fp) {
  			if (! @flock($fp, LOCK_SH | LOCK_NB))
  				@fclose($fp);
  		}

  		if ($fp) {
  			$data = "";
  			while (! @feof($fp)) {
  				$data .= @fread($fp, 131072);
  			}
  			@fclose($fp);
  			$result = true;
  		}

  	}
  	if( $result ) {
  		if( isset($_GET['dbdebug']) ) echo "OK ($filename)";
  	}

  	return $result;
  }

  function expire_cache_file( $filename ) {

  	$result = false;

    if (@is_readable($filename)) {
    	$mtime = @filemtime($filename);
    	$act_time = @time();

    	if ( $mtime < $act_time - $this->expires ) {
    		@unlink($filename);
    		$result = true;

    		if( isset($_GET['dbdebug']) ) echo "Expired ($filename)";
    	}
    }
    else {
    	if( isset($_GET['dbdebug']) ) echo "Not exists ($filename)";
    }


  	return $result;
  }
}

?>